\documentclass[a4paper, 11pt, oneside]{scrartcl}
\usepackage{lpp}
\usepackage{verbatim}

\begin{document}

\mtitle{Homework 1}

\sauthor{Rodrigo Barros Miguez}

\maff{Laboratory for Parallel Programming}{rodrigo.miguez@rwth-aachen.de}{}

\mabstract{Mesh generation is a crucial step for performing numerical simulations. A well constructed
mesh can define if the results obtained from a numerical code are accurate and efficient. Therefore,
in this homework number 1, a mesh generation code was utilized to get exposure to mesh generation
algorithms, to the RWTH Aachen University cluster usage, and C++ programming. This was done by filling
in the previously removed parts of the code, generating the results in the cluster, and visualizing
the data using paraview.}

\section{Introduction}

The importance of the grid generation process can be estimated by its development
over the past years, which turned out into a full field of research \cite{auth1}. A lot of effort has
been applied in research for different grid generation methods \cite{auth3, auth4}, and analysis of
the reliability of specific mesh types applied to numerical simulations \cite{auth2}.\\
In this homework, a simple mesh generation code was used to generate a 2D triangular
mesh for a rounded surface object. The important parts of the code implemented to obtain the mesh
are presented, and the visualization results are then depicted and discussed.

\section{Implementation and Results}

The code shown below represents the part that was implemented into the template provided. It has
three important parts: first the number of nodes and elements are obtained from the minf file, then
the nodes coordinates are read from be binary mxyz files, and finally the elements connectivity are
read from the binary mien file.

\begin{verbatim}

  ...

	file.open((settings->getMinfFile()).c_str(), ios::in);
	string buffer;
	while(file.good()) {
	  file >> buffer;
	  if (buffer == "nn") file >> this->nn;
	  if (buffer == "ne") file >> this->ne;
	}

	file.close();

  ...

  file.open((settings->getMxyzFile()).c_str(),ios::in|ios::binary|ios::ate);
  readStream = new char [nsd*sizeof(double)];
  file.seekg(0,ios::beg);

  int i;
  for(i = 0; i < nn; i++) {
    file.read(readStream, nsd*sizeof(double));
    swapBytes(readStream, nsd,sizeof(double));
    double *tmp = new double [nsd];
    tmp = (double*)readStream;

    node[i].setX(tmp[0]);
    node[i].setY(tmp[1]);
  }

  file.close();

  ...

	file.open((settings->getMienFile()).c_str(),ios::in|ios::binary|ios::ate);
	readStream = new char [nen*sizeof(int)];
	file.seekg(0,ios::beg);

	int j;
	for(i = 0; i < ne; i++) {
	  file.read(readStream, nen*sizeof(int));
	  swapBytes(readStream, nen ,sizeof(int));
	  file.seekg(nen*sizeof(int)*(i+1), ios::beg);
	  int *tmp = new int [nen];
	  tmp = (int*)readStream;
	  for(j = 0; j < nen; j++) {
      elem[i].setConn(j,tmp[j]-1);
	  }
	}

	file.close();

  ...
\end{verbatim}

The mesh generated by the code can finally be visualized using paraview. Figure 1 and 2 depicts the
cylinder crossction that was generated. As can be observed, the object represents a circular domain
formed by a triangular mesh with an empty cavity in its center.

As stated in the homework material, in a typical implementation, each mesh edge is generated multiple
times. To avoid that problem some algorithms can be applied. One option is to search the for duplicated
edges after the entire mesh is generated, so the duplicated edges that connects nodes A-B and B-A,
for example, can be fixed to only one ocurrence. Another possible option to avoid this problem is to
set a maximum number of edges that can be formed by each node, and define elements that share the same
edges so no aditional node connections are formed.

\begin{figure}[h]
\centering
\includegraphics[width=0.7\textwidth]{../test/mesh-4.png}
\caption{Plotted object.}
\end{figure}

\begin{figure}[h]
\centering
\includegraphics[width=0.7\textwidth]{../test/mesh-5.png}
\caption{Triangular mesh generated.}
\end{figure}


\pagebreak

\section{Conclusion}

In this homework a mesh generatiron code was used to create a cylindrical object in 2-dimensions
using a triangular mesh. The RWTH Aachen cluster was used to compile and run the final algorithm
and paraview was utilized to visualize the results. The object generated represents a circular
domain with a 2D cylindre cavity in the center. It was seen that mesh algorithms such as the one
used in this exercise generates multiple edges, and algorithms that search for edges between
similar nodes and either delete or merge those edges can be applied to avoid this issue.

\bibliographystyle{unsrt}
\bibliography{literature}

\end{document}
